#
# This file contains support Tcl code for the assignment of the default
# parameters to the global vectors of each ascend window
#

# Vector containing the name of the vector for each ascend window
global ascViewWindowVect

#
# proc Browser {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascBrowVect
#------------------------------------------------------------------------
proc Browser {args} {

  global ascBrowVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Browser"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascBrowVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascBrowVect($attr) $value
    return $value
  }
}


#
#
# proc Debugger {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascDebuVect
#------------------------------------------------------------------------
proc Debugger {args} {

  global ascDebuVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Debugger"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascDebuVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascDebuVect($attr) $value
    return $value
  }
}


#
#
# proc Display {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascDispVect
#------------------------------------------------------------------------
proc Display {args} {

  global ascDispVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Display"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascDispVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascDispVect($attr) $value
    return $value
  }
}


#
# This file contains support Tcl code for the assignment of the default
# parameters to the global vectors of each ascend window
#
#
# proc Global {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascGlobalVect
#------------------------------------------------------------------------
proc Global {args} {

  global ascGlobalVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Global"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascGlobalVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascGlobalVect($attr) $value
    return $value
  }
}


#
#
# proc Library {args}
#------------------------------------------------------------------------
# Sets the  default parameters for the vector ascLibrVect
#------------------------------------------------------------------------
proc Library {args} {

  global ascLibrVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Library"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascLibrVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascLibrVect($attr) $value
    return $value
  }
}


#
#
# proc Matrix {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascMtxVect
#------------------------------------------------------------------------
proc Matrix {args} {

  global ascMtxVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Matrix"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascMtxVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascMtxVect($attr) $value
    return $value
  }
}


#
#
# proc Probe {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascProbVect
#------------------------------------------------------------------------
proc Probe {args} {

  global ascProbVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Probe"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascProbVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascProbVect($attr) $value
    return $value
  }
}


#
#
# proc Script {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascScripVect
#------------------------------------------------------------------------
proc Script {args} {

  global ascScripVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Script"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascScripVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascScripVect($attr) $value
    return $value
  }
}


#
#
# proc Simulations {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascSimsVect
#------------------------------------------------------------------------
proc Simulations {args} {

  global ascSimsVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Simulations"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascSimsVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascSimsVect($attr) $value
    return $value
  }
}


#
#
# proc Solver {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascSolvVect
#------------------------------------------------------------------------
proc Solver {args} {

  global ascSolvVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Solver"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascSolvVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascSolvVect($attr) $value
    return $value
  }
}


#
#
# proc Toolbox {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascToolVect
#------------------------------------------------------------------------
proc Toolbox {args} {

  global ascToolVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Toolbox"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascToolVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascToolVect($attr) $value
    return $value
  }
}


#
#
# proc Units {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector ascUnitVect
#------------------------------------------------------------------------
proc Units {args} {

  global ascUnitVect

  if {$args == {}} {
    puts "ERROR: No arguments passed to Units"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $ascUnitVect($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set ascUnitVect($attr) $value
    return $value
  }
}


#
#
# proc Environment {args}
#------------------------------------------------------------------------
# Sets the default parameters for the vector env
#------------------------------------------------------------------------
proc Environment {args} {

  global env

  if {$args == {}} {
    puts "ERROR: No arguments passed to Environment"
    return
  }

  set ind 0
  set attr [lindex $args $ind]

  if {[llength $args] == 1} {
    return $env($attr)
  } else {
    incr ind
    set value [lrange $args $ind end]
    set env($attr) $value
    return $value
  }
}


#
#
# proc set_ViewVect_Values {}
#------------------------------------------------------------------------
# Define a vector containing the names of the vectors corresponding to each
# of the ASCEND window
#------------------------------------------------------------------------
proc set_ViewVect_Values {} {
  global ascViewWindowVect

  set ascViewWindowVect(browser) "ascBrowVect"
  set ascViewWindowVect(debugger) "ascDebuVect"
  set ascViewWindowVect(display) "ascDispVect"
  set ascViewWindowVect(global) "ascGlobalVect"
  set ascViewWindowVect(library) "ascLibrVect"
  set ascViewWindowVect(matrix) "ascMtxVect"
  set ascViewWindowVect(probe) "ascProbVect"
  set ascViewWindowVect(script) "ascScripVect"
  set ascViewWindowVect(simulations) "ascSimsVect"
  set ascViewWindowVect(solver) "ascSolvVect"
  set ascViewWindowVect(toolbox) "ascToolVect"
  set ascViewWindowVect(units) "ascUnitVect"
  set ascViewWindowVect(environment) "env"

  return
}

#
#
# proc set_View_Option_Values {}
#------------------------------------------------------------------------
# For the global vectors of ASCEND, this functions define an element
# called viewoptions, which are the names of other array elements (in
# the same vector) that the user may want be able to get and modify.
#------------------------------------------------------------------------
proc set_View_Option_Values {} {

  global ascBrowVect ascDebuVect ascDispVect ascGlobalVect ascLibrVect
  global ascMtxVect ascProbVect ascScripVect ascSimsVect ascSolvVect
  global ascToolVect ascUnitVect env

  View_InitDialog
  set ascBrowVect(viewoptions) [list \
    TypeorValue \
    queryfile \
    geometry \
    minsize \
    iconname \
    initialstate \
    visibility \
  ]
  set ascDebuVect(viewoptions) [list \
    geometry \
    minsize \
    iconname \
    initialstate \
    iterationlimit \
    visibility \
   ]
  set ascDispVect(viewoptions) "geometry minsize iconname initialstate font"
  set ascGlobalVect(viewoptions) "font labelfont"
  set ascLibrVect(viewoptions) [list \
    geometry \
    minsize \
    iconname \
    initialstate \
    visibility \
    entryFont \
  ]
  set ascMtxVect(viewoptions) ""
  set ascProbVect(viewoptions) [list \
    geometry \
    minsize \
    iconname \
    initialstate \
    visibility \
  ]
  set ascScripVect(viewoptions) [list \
    geometry \
    minsize \
    iconname \
    initialstate \
    visibility
  ]
  set ascSimsVect(viewoptions) [list \
    geometry \
    minsize \
    iconname \
    initialstate \
    visibility
  ]
  set ascSolvVect(viewoptions) [list \
    geometry \
    minsize \
    iconname \
    initialstate \
    visibility \
    iterationlimit \
    feastol \
    pivottol \
    singtol \
    timelimit \
    trapFPEdefault \
    modelbar
  ]
  set ascToolVect(viewoptions) [list geometry minsize iconname initialstate]
  set ascUnitVect(viewoptions) [list \
    precision geometry minsize iconname initialstate]
  set env(viewoptions) ""
  return
}

#
#
# proc View_Options {window}
#------------------------------------------------------------------------
# return the value of the array element viewoptions for the global vector
# of the ASCEND window given by the argument window.
#------------------------------------------------------------------------
proc View_Options {window} {

  global ascBrowVect ascDebuVect ascDispVect ascGlobalVect ascLibrVect
  global ascMtxVect ascProbVect ascScripVect ascSimsVect ascSolvVect
  global ascToolVect ascUnitVect env
  global ascViewWindowVect

  set_ViewVect_Values
  set_View_Option_Values

  set vectorname $ascViewWindowVect($window)
  return ${vectorname}(viewoptions)
}


#
# proc View_Get_Proc_Name {window}
#------------------------------------------------------------------------
# take a util default subscript and return its variable
# for the utility box. you better have set these vars
# elsewhere or trap those not ever set
#------------------------------------------------------------------------
proc View_Get_Proc_Name {window} {
  switch $window {
    {browser}         {return "Browser"}
    {debugger}        {return "Debugger"}
    {display}         {return "Display"}
    {global}          {return "Global"}
    {library}         {return "Library"}
    {matrix}          {return "Matrix"}
    {probe}           {return "Probe"}
    {script}          {return "Script"}
    {simulations}     {return "Simulations"}
    {solver}          {return "Solver"}
    {toolbox}         {return "Toolbox"}
    {units}           {return "Units"}
    {environment}     {return "Environment"}
    default       {error "View_Get_Proc_Name called with bad option $window"}
  }
}

#
# proc View_Save_Values {}
#------------------------------------------------------------------------
# save ascend.ad  overwriting the previous file
#------------------------------------------------------------------------
proc View_Save_Values {} {

  global env

  set window_list [list \
    browser debugger display global library matrix \
    probe script simulations solver toolbox units environment
  ]

  if {[catch {set ascendfile [open ~/.ascend.ad w]} ]} {
    puts "Error writing ~/.ascend.ad"
    return
  }

  puts $ascendfile "\#"
  puts $ascendfile "\# This is a generated file containing the Tcl code for"
  puts $ascendfile "\# the assignment of the Application DEFAULTs."
  puts $ascendfile "\#"
  puts $ascendfile " "

  foreach win $window_list {
    set windowproc [View_Get_Proc_Name $win]
    set option_list [View_Options $win]
    foreach opt $option_list {
      set value [$windowproc $opt]
      puts $ascendfile "$windowproc $opt $value"
    }
  }
  close $ascendfile
  puts stdout "Wrote ~/.ascend.ad file."
}


# proc View_InitDialog {}
#-------------------------
# init vector to control 
# info save.
#-------------------------
proc View_InitDialog {} {
  global ascViewSaveVect
  global tcl_platform ascViewSaveVect env
  # we should move all but ~/.ascendrc in ~/.ascend-setup/* files,
  # where we make .ascend-setup a directory in ~.
  # then we can have as many setup files as needed for different
  # things. .ascend.ad should go here, as a bunch of other things'
  # so the user can control which get overwritten on a save.
  set ascViewSaveVect(grab) 0
  set ascViewSaveVect(cancellable) 1
  set ascViewSaveVect(entrywidth) 20
  set ascViewSaveVect(npages) 1
  set ascViewSaveVect(toplevel) .viewsaveconfig
  set ascViewSaveVect(title) "Session save options"
  set ascViewSaveVect(helpcommand) {Help_button view}
  set ascViewSaveVect(usercheckcommand) ""
  set ascViewSaveVect(whenokcommand) {beep; puts "call save fcns"}
  set ascViewSaveVect(namelist) [list \
    windowpositions \
    fonts \
    colors \
    scriptsloaded \
  ]
  set ascViewSaveVect(windowpositions) 1
  set ascViewSaveVect(fonts) 1
  set ascViewSaveVect(colors) 1
  set ascViewSaveVect(scriptsloaded) 1
  set ascViewSaveVect(windowpositions.label) "Save window placements"
  set ascViewSaveVect(fonts.label) "Save current font selections"
  set ascViewSaveVect(colors.label) "Save current color selections"
  set ascViewSaveVect(scriptsloaded.label) "Save names of loaded scripts"
  set ascViewSaveVect(windowpositions.type) bool
  set ascViewSaveVect(fonts.type) bool
  set ascViewSaveVect(colors.type) bool
  set ascViewSaveVect(scriptsloaded.type) bool
  # should append solver page names as booleans here
  # each, if TRUE, saves that solver to a solverid file.
  # when we can save sims, should include sims list, too.

  # of course whatever we can save, we should also define
  # the automatic setup to do properly.
  # to keep things simple, the user's ascend.ad should have
  # lines that source all the other config files written into it.
} 
