# Utility wijndow code for ascend
# (C) Ben Allan 1994
# $Revision: 1.7 $
# $Date: 97/06/16 19:10:31 $
#
#
# proc VShowWindow.util {args}
#------------------------------------------------------------------------
# procedure to show window .util
# builds a line for every thing in utilvect
# but in sets of ascglobalbect(maxutilrow)
# pages are numbered from 0 internally
# if a line is called for without the variable
# set first, this will set it to something dumb but displayable
#------------------------------------------------------------------------
proc VShowWindow.util {args} {

  global ascUtilVect ascGlobalVect
  Util_Init
  set rows [array size ascUtilVect]
  if {$rows ==0 } {return}
  set lblwid [Util_Label_Width]
  # build widget .util
  if {[info commands .util] != ""} {set utilup 1} {set utilup 0}

  set argc [llength $args]
  if {$argc==1} {
    set nrows $ascGlobalVect(maxutilrow)
    set pagenum $args
    set maxpage [expr [llength [array names ascUtilVect]] / $nrows]
    if {[expr $rows % $nrows] ==0} { incr maxpage -1}
    if {$maxpage==0} {set nomore 1} {set nomore 0}
  }  else {error "VShowWindow.util wants 1 page num arg"}

  if {!$utilup} {
    # Window manager configurations
    toplevel .util
    wm positionfrom .util user
    wm sizefrom .util user
    wm minsize .util 10 10
    wm protocol .util WM_DELETE_WINDOW {Util_do_OK}
    wm title .util {ASCEND Utilities}


    # build widget .util.box
    frame .util.box \
      -borderwidth {0} \
      -relief {raised}

    # build widget .util.box.label
    label .util.box.label \
      -font $ascGlobalVect(labelfont) \
      -borderwidth {5} \
      -relief {groove} \
      -text {ASCEND Utility Settings}

    # build widget .util.box.main_frm
    frame .util.box.main_frm \
      -borderwidth {2} \
      -relief {raised}

    # build widget .util.box.main_frm.lbl_frm
    frame .util.box.main_frm.lbl_frm \
      -relief {raised}

    # build widget .util.box.main_frm.val_frm
    frame .util.box.main_frm.val_frm \
      -relief {raised}
  }

  if {[expr $pagenum >= $maxpage]} {
    set nextpage 0
    set pagenum $maxpage
  } else {
    set nextpage [expr $pagenum +1]
  }
  set subs [lsort [array names ascUtilVect]]
  set first [expr $pagenum * $nrows]
  set last [expr $first + $nrows -1]
  set psubs [lrange $subs $first $last]

# forget anyone who's packed now in val_frm or lbl_frm
  set slaves "[winfo children .util.box.main_frm.lbl_frm]"
  append slaves " [winfo children .util.box.main_frm.val_frm]"
  foreach s $slaves {pack forget $s}
# build all the entries, if not out there, and pack, if on current page
  foreach s $subs {
#
# init unset vars
    set varname [Util_Get_Var $s]
    global $varname
    if {[info var $varname]==""} {
      set $varname "unset"
    }
    if {[info command ".util.box.main_frm.lbl_frm.$s"] ==""} {
# build widget .util.box.main_frm.lbl_frm.$s
      set tmplbl "[Util_Get_Label $s]"
      label .util.box.main_frm.lbl_frm.$s \
        -font $ascGlobalVect(font) \
        -width "$lblwid" \
        -text "[Util_Get_Label $s]"
      catch {
        set btnpath [string trim $tmplbl]
        set btnpath [string tolower $btnpath]
        set btnpath [join [split $btnpath] .]
        Help_BindButton .util.box.main_frm.lbl_frm.$s utilities $btnpath
      }
# build widget .util.box.main_frm.val_frm.$s
      entry .util.box.main_frm.val_frm.$s \
        -font $ascGlobalVect(font) \
        -borderwidth {3} \
        -exportselection 0 \
        -relief {groove} \
        -textvariable "$varname"
    }

    if {[lsearch $psubs $s] != "-1"} {
# pack widget .util.box.main_frm.lbl_frm, if displayed on this page
      pack append .util.box.main_frm.lbl_frm \
        .util.box.main_frm.lbl_frm.$s {top frame center expand fill}
# pack widget .util.box.main_frm.val_frm if displayed on this page
      pack append .util.box.main_frm.val_frm \
        .util.box.main_frm.val_frm.$s {top frame center expand fill}
    }
  }
# pack rest if not done already
  if {!$utilup} {
    # pack widget .util.box.main_frm
    pack append .util.box.main_frm \
      .util.box.main_frm.lbl_frm {left frame center fill} \
      .util.box.main_frm.val_frm {left frame center expand fill}

    # build widget .util.box.mb_frm
    frame .util.box.mb_frm \
      -relief {raised}

    # build widget .util.box.mb_frm.btn_hlp
    button .util.box.mb_frm.btn_hlp \
      -font $ascGlobalVect(font) \
      -command {Util_do_Help} \
      -text { Help }

    # build widget .util.box.mb_frm.btn_ok
    button .util.box.mb_frm.btn_ok \
      -font $ascGlobalVect(font) \
      -command {Util_do_OK} \
      -text {  OK  }

    # build widget .util.box.mb_frm.btn_read
    button .util.box.mb_frm.btn_read \
      -font $ascGlobalVect(font) \
      -command {Util_do_Read} \
      -text { Read }

    # build widget .util.box.mb_frm.btn_save
    button .util.box.mb_frm.btn_save \
      -font $ascGlobalVect(font) \
      -command {Util_do_Save} \
      -text { Save }

    # build widget .util.box.mb_frm.btn_more
    if {!$nomore} {
      button .util.box.mb_frm.btn_more \
        -font $ascGlobalVect(font) \
        -command "VShowWindow.util $nextpage" \
        -text { More }

    # pack widget .util.box.mb_frm
      pack append .util.box.mb_frm \
        .util.box.mb_frm.btn_ok {left frame center expand fill} \
        .util.box.mb_frm.btn_save {left frame center expand fill} \
        .util.box.mb_frm.btn_read {left frame center expand fill} \
        .util.box.mb_frm.btn_more {left frame center expand fill} \
        .util.box.mb_frm.btn_hlp {left frame center expand fill}
    } else {
      pack append .util.box.mb_frm \
        .util.box.mb_frm.btn_ok {left frame center expand fill} \
        .util.box.mb_frm.btn_save {left frame center expand fill} \
        .util.box.mb_frm.btn_read {left frame center expand fill} \
        .util.box.mb_frm.btn_hlp {left frame center expand fill}
    }
    # pack widget .util.box
    pack append .util.box \
      .util.box.label {top frame center fillx} \
      .util.box.mb_frm {bottom frame center fill} \
      .util.box.main_frm {top frame center expand fill}

    # pack widget .util
    pack append .util \
      .util.box {top frame center expand fill}

    if {"[info procs XFEdit]" != ""} {
      catch "XFMiscBindWidgetTree .util"
      after 2 "catch {XFEditSetShowWindows}"
    }
  } else {
    if {!$nomore} {
      .util.box.mb_frm.btn_more config -command "VShowWindow.util $nextpage"
    }
  }
}

# proc DestroyWindow.util {}
proc DestroyWindow.util {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .util]" != ""} {
      global xfShowWindow.util
      set xfShowWindow.util 0
      XFEditSetPath .
      after 2 "XFSaveAsProc .util; XFEditSetShowWindows"
    }
  } {
    catch "destroy .util"
    update
  }
}

