/*
 *  Basic Definitions for Ascend
 *  by Tom Epperly
 *  Version: $Revision: 1.16 $
 *  Version control file: $RCSfile: compiler.h,v $
 *  Date last modified: $Date: 97/07/28 20:52:07 $
 *  Last modified by: $Author: ballan $
 *  Part of Ascend
 *
 *  This file is part of the Ascend Language Interpreter.
 *
 *  Copyright (C) 1990, 1993, 1994 Thomas Guthrie Epperly
 *
 *  The Ascend Language Interpreter is free software; you can redistribute
 *  it and/or modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 *
 *  The Ascend Language Interpreter is distributed in hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with the program; if not, write to the Free Software Foundation,
 *  Inc., 675 Mass Ave, Cambridge, MA 02139 USA.  Check the file named
 *  COPYING.
 *
 *  This module defines the fundamental constants used by the rest of
 *  Ascend and pulls in system headers.
 *  There is not corresponding compiler.c. The variables
 *  declared in this header are defined in ascParse.y.
 *
 *  This header and Tcl/Tk headers are known to conflict. This header
 *  should be included AFTER tcl.h or tk.h, not before.
 */

#ifndef __COMPILER_H_SEEN__
#define __COMPILER_H_SEEN__


typedef CONST char symchar;
/*
 * just a name so we can be clear about strings coming from
 * symbol tables. If it's a pair of symchar *, it is a sufficient
 * comparison to compare the pointers if only equality is sought.
 * WARNING: this typedef may change in the future when we get a
 * real symbol table. avoid treating symchar directly as char *.
 */
#define SCP(s) (s)
/*
 * SCP(s) returns the string ptr from a symchar, whatever a symchar is.
 */
/* globals from ascParse.y that yacc won't put in ascParse.h generated. */


extern int g_compiler_warnings;
/*
 *  Flag to turn on lintlike ASCEND whinings in various ways.
 *  higher values mean more spew. 0 = no warnings.
 *  Variable is declared in ascParse.y.
 */

extern int g_parse_relns;
/* abandon relation productions - bad idea */

extern struct StatementList *g_statementlist_ptr;
/* from ascParse.y */

/* from ascParse.y */

#define BASE_REAL_NAME          "real"
#define BASE_INTEGER_NAME       "integer"
#define BASE_SYMBOL_NAME        "symbol"
#define BASE_BOOLEAN_NAME       "boolean"
#define BASE_SET_NAME           "set"
/*** Above are the simple types eligible to be ATOM children. ***/
/*** Below are the simple types NOT eligible to be ATOM children. ***/
#define BASE_CON_REAL_NAME      "real_constant"
#define BASE_CON_INTEGER_NAME   "integer_constant"
#define BASE_CON_BOOLEAN_NAME   "boolean_constant"
#define BASE_CON_SYMBOL_NAME    "symbol_constant"
/* relation, etc names */
#define BASE_REL_NAME "relation"
#define BASE_LOGREL_NAME "logic_relation"
#define BASE_WHEN_NAME "when"
#define BASE_EXT_NAME "EXTERNAL_MODEL"
#define BASE_UNSELECTED "unSELECTed_part"
/*
 *  Don't randomly change these, as ASCEND MODEL code assumes they
 *  are what they are. Changing these constitutes requiring a global
 *  revision of ASCEND models.
 */

#endif /* __COMPILER_H_SEEN__ */
