/*
 *  Temporary Procedure Output
 *  by Tom Epperly
 *  Created: 1/10/90
 *  Version: $Revision: 1.7 $
 *  Version control file: $RCSfile: procio.c,v $
 *  Date last modified: $Date: 97/07/18 12:32:50 $
 *  Last modified by: $Author: mthomas $
 *
 *  This file is part of the Ascend Language Interpreter.
 *
 *  Copyright (C) 1990, 1993, 1994 Thomas Guthrie Epperly
 *
 *  The Ascend Language Interpreter is free software; you can redistribute
 *  it and/or modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 *
 *  The Ascend Language Interpreter is distributed in hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with the program; if not, write to the Free Software Foundation, Inc., 675
 *  Mass Ave, Cambridge, MA 02139 USA.  Check the file named COPYING.
 */
#include<math.h>
#include<stdio.h>
#include "utilities/ascConfig.h"
#include "compiler/compiler.h"
#include "general/list.h"
#include "compiler/fractions.h"
#include "compiler/dimen.h"
#include "compiler/functype.h"
#include "compiler/types.h"
#include "compiler/stattypes.h"
#include "compiler/slist.h"
#include "compiler/statio.h"
#include "compiler/instance_enum.h"
#include "compiler/initialize.h"
#include "compiler/proc.h"
#include "compiler/procio.h"

#ifndef lint
static CONST char ProcedureIORCSid[] = "$Id: procio.c,v 1.7 97/07/18 12:32:50 mthomas Exp $";
#endif

void WriteProcedure(FILE *f, struct InitProcedure *p)
{
  FPRINTF(f,"METHOD %s;\n",ProcName(p));
  WriteStatementList(f,ProcStatementList(p),4);
  FPRINTF(f,"END %s;\n",ProcName(p));
}
