/*
 *  Exceptions.c
 *  by Kirk Abbott and Ben Allan
 *  Created: 1/94
 *  Version: $Revision: 1.8 $
 *  Version control file: $RCSfile: Exceptions.c,v $
 *  Date last modified: $Date: 97/07/18 12:22:58 $
 *  Last modified by: $Author: mthomas $
 *
 *  This file is part of the ASCEND Tcl/Tk interface
 *
 *  Copyright 1997, Carnegie Mellon University
 *
 *  The ASCEND Tcl/Tk interface is free software; you can redistribute
 *  it and/or modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 *
 *  The ASCEND Tcl/Tk interface is distributed in hope that it will be
 *  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with the program; if not, write to the Free Software Foundation,
 *  Inc., 675 Mass Ave, Cambridge, MA 02139 USA.  Check the file named
 *  COPYING.  COPYING is found in ../compiler.
 */

#include <signal.h>
#include <setjmp.h>
#include "utilities/ascConfig.h"
#include "interface/Exceptions.h"

#ifndef lint
static CONST char ExceptionsID[] = "$Id: Exceptions.c,v 1.8 97/07/18 12:22:58 mthomas Exp $";
#endif


jmp_buf g_brow_env,
        g_slv_fp_env, g_slv_int_env,
        g_libr_env, g_unit_env, g_env;


void (*fault_set_seg_trap(void (*trapptr)(int)))(int)
{
  void (*lasttrap)(int);
  if ((lasttrap=signal(SIGSEGV,trapptr))==SIG_ERR) {
    FPRINTF(ASCERR,"Segmentation fault trap set failed!\n");
    FFLUSH(ASCERR);
  }
  return lasttrap;
}

void (*fault_set_int_trap(void (*trapptr)(int)))(int)
{
  void (*lasttrap)(int);
  if ((lasttrap=signal(SIGINT,trapptr))==SIG_ERR) {
    FPRINTF(ASCERR,"Interrupt trap set failed!\n");
    FFLUSH(ASCERR);
  }
  return lasttrap;
}

void (*fault_set_fp_trap(void (*trapptr)(int)))(int)
{
  void (*lasttrap)(int);
  if ((lasttrap=signal(SIGFPE,trapptr))==SIG_ERR) {
    FPRINTF(ASCERR,"Floating point trap set failed!\n");
    FFLUSH(ASCERR);
  }
  return lasttrap;
}
